\name{ansc}
\docType{data}

\alias{ansc}

\title{PAD  -  Quarteto de dados de Anscombe}

\usage{data(ansc)}

\description{
O \code{ansc} data frame tem 11 linhas e 6 colunas.

Este conjunto de dados sinteticos foi construido pelo estatistico Frank Anscombe para ilustrar como residuos podem ser usados para discriminar dados que sao identicos entre si ajustando em modelos de regressao.

}

\format{
  Este data frame contem as seguintes colunas:
  \describe{
    \item{x1}{um vetor numerico com variavel explicativa para cada uma das respostas 1, 2 ou 3.  }
    \item{y1}{um vetor numerico com resposta 1.  }
    \item{y2}{um vetor numerico com resposta 2.  }
    \item{y3}{um vetor numerico com resposta 3.  }
    \item{x4}{um vetor numerico com variavel explicativa para a resposta 4}
    \item{y4}{um vetor numerico com resposta 4.  }
  }
}

%\details{
% ~~ Se necessario, mais detalhes do que a descricao acima ~~
%}

\source{
Anscombe, Francis J. (1973) Graphs in statistical analysis. American Statistician, 27, 17-21. 
}

%\references{
%~~ possibilidade secundaria de fontes e usos ~~
%}

\examples{
data(ansc)
summary(ansc)
parmf <- par()$mfrow
par(mfrow=c(2,2))
with(ansc, plot(x1, y1))
with(ansc, plot(x1, y2))
with(ansc, plot(x1, y3))
with(ansc, plot(x4, y4))
par(mfrow=parmf)
}

\keyword{datasets}
